#!/usr/bin/env python
#-*- coding: utf-8 -*-

# Inspire by Conbagui tutorial found here: http://fav.me/ddit8ur
# author: Pocholo
#         MrQ: use ACTIVE BRUSH OR TEXT with "Clipboard Mask" fix gimp_context_set_pattern ("Clipboard") only works on English versions of Gimp
# date: 6/6/20

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugin folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.


from gimpfu import *
import gettext
import os, sys,time 

# fix pdb.gimp_context_get_brush("Clipboard Mask") only works on English versions of Gimp

gettext.install("gimp20", gimp.locale_directory, unicode=True)

def pm_icon_pressed_effect_all(use, text, font, direction, just, letter_spacing, line_spacing, size, bgColor, fgColor):
      
   pdb.gimp_context_push()
   #size = 550
   x = size/550
   # image = pdb.gimp_image_new(width, height, type)
   img = pdb.gimp_image_new(size, size, RGB)
   # layer = pdb.gimp_layer_new(image, width, height, type, name, opacity, mode)
   draw = pdb.gimp_layer_new(img, size, size, RGB_IMAGE, "icon_pressed_effect", 100, 0)
   img.add_layer(draw, 0)
   gimp.Display(img)
   
   pdb.gimp_image_select_item(img, 2, draw)
   channel = pdb.gimp_selection_save(img)
      
   pdb.gimp_image_remove_layer(img, draw)
      
   #Create a transparent background
   backLayer = pdb.gimp_layer_new(img, size, size, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
   pdb.gimp_image_add_layer(img, backLayer, 0)
   pdb.gimp_layer_add_alpha(backLayer)
   pdb.gimp_drawable_fill(backLayer, FILL_TRANSPARENT)
 
   
   #Create the icon background
   #pdb.gimp_image_select_round_rectangle(image, operation, x, y, width, height, corner_radius_x, corner_radius_y)
   pdb.gimp_image_select_round_rectangle(img, 2, 19*x, 19*x, 512*x, 512*x, 50*x, 50*x)
   pdb.gimp_context_set_background(bgColor)
   pdb.gimp_drawable_edit_fill(backLayer, FILL_BACKGROUND)
   #pdb.gimp_context_set_foreground(fgColor)
   #pdb.gimp_edit_blend(drawable, blend_mode, paint_mode, gradient_type, opacity, offset, repeat, reverse, supersample, max_depth, threshold, dither, x1, y1, x2, y2)
   #blend_mode  BLEND-FG-BG-RGB (0), BLEND-FG-BG-HSV (1), BLEND-FG-TRANSPARENT (2), BLEND-CUSTOM (3)
   #pdb.gimp_edit_blend(backLayer, 0, LAYER_MODE_NORMAL, 0, 100, 0, 0, FALSE, TRUE, 5, 0.20, TRUE, 275, 20, 275, 275)
   
   #Create a copy
   non_empty = pdb.gimp_edit_copy(backLayer)
   copyLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Copy", 100, LAYER_MODE_NORMAL)
   pdb.gimp_image_add_layer(img, copyLayer, 0)
   pdb.gimp_layer_add_alpha(copyLayer)
   pdb.gimp_drawable_fill(copyLayer, FILL_TRANSPARENT)
   floating_sel = pdb.gimp_edit_paste(copyLayer, FALSE)
   pdb.gimp_floating_sel_anchor(floating_sel)
   
   #Gaussian blur and merge
   pdb.gimp_image_select_item(img, 2, copyLayer)
   pdb.plug_in_gauss_rle2(img, copyLayer, 120, 120)
   backLayer = pdb.gimp_image_merge_visible_layers(img, 2)
   pdb.gimp_selection_none(img)
      
   #Create icon layer
   iconLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Icon", 100, LAYER_MODE_NORMAL)
   pdb.gimp_image_add_layer(img, iconLayer, 0)
   pdb.gimp_layer_add_alpha(iconLayer)
   pdb.gimp_drawable_fill(iconLayer, FILL_TRANSPARENT)
   
   pdb.gimp_image_clean_all(img)   
   newimg = pdb.gimp_image_new(size, size, RGB)
   pdb.gimp_layer_new(newimg, size, size, RGB, "Brush", 100, LAYER_MODE_NORMAL)
   
   if use==0:
      text_layer = pdb.gimp_text_fontname(newimg, None, 0, 0, text, 0, 1, 150*x, PIXELS, font)
      pdb.gimp_text_layer_set_base_direction (text_layer, direction)
      pdb.gimp_text_layer_set_justification (text_layer, just)
      pdb.gimp_text_layer_set_letter_spacing(text_layer, letter_spacing)
      pdb.gimp_text_layer_set_line_spacing(text_layer, line_spacing)
      pdb.gimp_text_layer_set_color(text_layer, (0,0,0))
      pdb.gimp_image_resize_to_layers(newimg)
      pdb.gimp_image_set_active_layer(newimg,text_layer)
      layer_copy = pdb.gimp_layer_new_from_visible(newimg, newimg, "Brush")
   
      pdb.gimp_image_add_layer(newimg, layer_copy, 0)
      pdb.gimp_context_set_foreground((255,255,255))
      pdb.gimp_drawable_fill(text_layer, 0)
      mask = pdb.gimp_image_merge_down(newimg, layer_copy, 0)
      copy = pdb.gimp_edit_copy(mask)
      pdb.gimp_image_remove_layer(newimg, mask)
      pdb.gimp_context_set_brush (_("Clipboard Mask"))
	  
   if use==1:	   
       iconLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Icon", 100, LAYER_MODE_NORMAL)
       pdb.gimp_image_add_layer(img, iconLayer, 0)
       pdb.gimp_layer_add_alpha(iconLayer)
       pdb.gimp_drawable_fill(iconLayer, FILL_TRANSPARENT)
       brush = pdb.gimp_context_get_brush()
       pdb.gimp_context_set_brush (brush) 
   
   pdb.gimp_context_set_brush_size(450*x)
   pdb.gimp_context_set_brush_aspect_ratio(0)
   pdb.gimp_context_set_brush_angle(0)
   pdb.gimp_context_set_brush_spacing(10*x)
   pdb.gimp_context_set_brush_hardness(1)
   pdb.gimp_context_set_brush_force(1)
   pdb.gimp_context_set_foreground (fgColor)
   pdb.gimp_paintbrush_default(iconLayer, 2, [275*x, 275*x])
      
   #Drop Shadow
   pdb.python_layerfx_drop_shadow(img, iconLayer,
								(190, 125, 207),   #color
								30,                #opacity75
								0,                 #contou - linear
								0,                 #noise
								4,                 #mode - overlay 5  LAYER-MODE-DIVIDE-LEGACY (15)
								0,                 #spread
								1,                 #size
								100,               #offset_angle
								2,                 #offset_distance
								TRUE,              #knockout
								FALSE)             #merge
   
   
   #Text inner shadow
   pdb.python_layerfx_inner_shadow(img, iconLayer,
								(0, 0, 0),   #color
								30,          #opacity
								0,           #contou -linear
								0,           #noise
								3,           #mode - multiply
								1,           #source
								0,           #choke
								6,           #size
								100,         #offset_angle
								8,           #offset_distance
								FALSE)       #merge
   
   
   #Inner Glow                           
   pdb.python_layerfx_inner_glow(img, iconLayer,
								(0, 0, 0),   #color
								30,          #opacity
								0,           #contou - linear
								0,           #noise
								3,           #mode - multiply
								1,           #source
								0,           #choke
								3,           #size
								FALSE)       #merge
   
   
   #Bevel and Emboss   
   backLayer = pdb.gimp_image_get_layer_by_name(img, "Background")
   pdb.gimp_image_set_active_layer(img, backLayer)
   pdb.python_layerfx_bevel_emboss(img, backLayer,
								1,                #style inner bevel
								65,               #depth
								0,                #direction
								3,                #size
								4,                #soften
								100,              #angle
								30,               #altitude
								0,                #gloss_contour - linear
								(255, 255, 255),  #highlight_color
								4,                #highlight_mode-screen
								75,               #highlight_opacity
								(78, 48, 0),      #shadow_color
								3,                #shadow_mode-multiply
								20,               #shadow_opacity
								0,                #surface_contour - linear
								FALSE,            #use_texture
								"Dried mud",      #pattern
								100,              #scale
								100,              #tex_depth
								TRUE,             #invert
								FALSE)            #merge   
   
   #  
   #Resets the previous user defaults
   pdb.gimp_context_pop()
      
register(
	"pm_icon_pressed_effect_all",
	"Creates a pressed icon for use:\n\n  1.Text (with Clipboard Mask)\n  2. Active brush.",
	"Creates a pressed icon for text",
	"Pocholo & MrQ",
	"GPL",
	"2020",
	"Pressed effect for text or brush",
	"",
	[
	#(PF_IMAGE, "img", "Input image", None),
	#(PF_DRAWABLE, "draw", "Input drawable", None),
	(PF_OPTION, "use", "Use:", 0, [" TEXT "," ACTIVE BRUSH "]),	
	(PF_TEXT, 	"text", ("Text:"), "GIMP\nCHAT"),
	(PF_FONT, "font", "Font:", "Arial"),
	(PF_OPTION,  "Direction", "Direction:", 0, ["From left to right",  "From right to left", "Vertical, right to left (mixed orientation)", "Vertical, right to left (upright orientation)", "Vertical, left to right (mixed orientation)", "Vertical, left to right (upright orientation)"]),
	(PF_OPTION, "just", "Justify:", 2, ["LEFT","RIGHT","CENTER","FILL"]),
	(PF_SPINNER, "letter_spacing", "Letter Spacing:", 0, (-100, 100, 1, 5, 0, 0)),
	(PF_SPINNER, "line_spacing", "Line Spacing:", 0, ( -100, 100, 1, 5, 0, 0)),
	(PF_ADJUSTMENT, "size", "Icon size:", 550, (200, 1000, 1)),
	(PF_COLOR, "bgColor", "Background color:", (150, 84, 180)),
	(PF_COLOR, "fgColor", "Brush color:", (71, 30, 85)),
	],
	[],
	pm_icon_pressed_effect_all,
	menu="<Image>/Pocholo-scripts/Icon pressed effect",
	domain=("gimp20", gimp.locale_directory))
main()      

